/* RAW socket utility routine:
 * 
 * Write out an IP header.
 * shadows@whitefang.com
 * Thamer Al-Herbish
 */

#include <stdlib.h>
#include <stdio.h>

#include <sys/types.h>
#include <sys/socket.h>

#include <netinet/in.h>
#include <arpa/inet.h>

#include <netinet/in_systm.h>
#include <netinet/ip.h>

#include <unistd.h>
#include <string.h>

#if !defined(HAVE_INCKSUM)
#include <checksum.h>
#endif

#define DEFAULT_TTL 60  /* Just hard code the ttl in the ip header.*/

int ip_chk(char *packet, unsigned char protocol, struct in_addr *saddr,
	    struct in_addr *daddr)
{
  int result = 0;
  struct iphdr *iphdr;

  iphdr = (struct iphdr *)packet;
  
  if (protocol && iphdr->protocol != protocol)
    result++;
  if (saddr != NULL && iphdr->saddr != saddr->s_addr)
    result++;
  if (daddr != NULL && iphdr->daddr != daddr->s_addr)
    result++;
  /*
  iphdr->check = (unsigned short)in_cksum((unsigned short *)iphdr,
					  sizeof(struct iphdr));
  */
  return(result);
}

void ip_chkx(char *packet, unsigned char *protocol,
	     struct in_addr *saddr, struct in_addr *daddr)
{
  struct iphdr *iphdr;

  iphdr = (struct iphdr *)packet;
  
  if (protocol != NULL)
    *protocol = iphdr->protocol;
  if (saddr != NULL)
    saddr->s_addr = iphdr->saddr;
  if (daddr != NULL)
    daddr->s_addr = iphdr->daddr;
}

int ip_length(char *packet)
{
  struct iphdr *iphdr;

  iphdr = (struct iphdr *)packet;
  
  return(ntohs(iphdr->tot_len));
}

int ip_ihl(char *packet)
{
  struct iphdr *iphdr;

  iphdr = (struct iphdr *)packet;
  
  return(iphdr->ihl);
}
